#include "main.h"

void SystemClock_Config(void);
static void MX_GPIO_Init(void);

int main(void)
{

  HAL_Init();

  SystemClock_Config();

  MX_GPIO_Init();

  while (1)
  {
	  // Buzzer test
	  HAL_GPIO_WritePin(DO_Buzzer_GPIO_Port, DO_Buzzer_Pin, SET);
	  HAL_Delay(2 00);
	  HAL_GPIO_WritePin(DO_Buzzer_GPIO_Port, DO_Buzzer_Pin, RESET);
	  HAL_Delay(500);
	  // Relay1 test
	  HAL_GPIO_WritePin(DO_Relay1_GPIO_Port, DO_Relay1_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_Relay1_GPIO_Port, DO_Relay1_Pin, RESET);
	  HAL_Delay(500);
	  // Relay2 test
	  HAL_GPIO_WritePin(DO_Relay2_GPIO_Port, DO_Relay2_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_Relay2_GPIO_Port, DO_Relay2_Pin, RESET);
	  HAL_Delay(500);
	  // Red1 led test
	  HAL_GPIO_WritePin(DO_RLED1_GPIO_Port, DO_RLED1_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_RLED1_GPIO_Port, DO_RLED1_Pin, RESET);
	  HAL_Delay(500);
	  // Red2 led test
	  HAL_GPIO_WritePin(DO_RLED2_GPIO_Port, DO_RLED2_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_RLED2_GPIO_Port, DO_RLED2_Pin, RESET);
	  HAL_Delay(500);
	  // Green led test
	  HAL_GPIO_WritePin(DO_GLED_GPIO_Port, DO_GLED_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_GLED_GPIO_Port, DO_GLED_Pin, RESET);
	  HAL_Delay(500);
	  // Blue led test
	  HAL_GPIO_WritePin(DO_BLED_GPIO_Port, DO_BLED_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_BLED_GPIO_Port, DO_BLED_Pin, RESET);
	  HAL_Delay(500);
	  // Yellow led test
	  HAL_GPIO_WritePin(DO_YLED_GPIO_Port, DO_YLED_Pin, SET);
	  HAL_Delay(500);
	  HAL_GPIO_WritePin(DO_YLED_GPIO_Port, DO_YLED_Pin, RESET);
	  HAL_Delay(500);
  }
}

void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  HAL_RCC_OscConfig(&RCC_OscInitStruct);
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;
  HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2);
}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, DO_YLED_Pin|DO_BLED_Pin|DO_GLED_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, DO_RLED2_Pin|DO_RLED1_Pin|DO_Relay2_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, DO_Buzzer_Pin|DO_Relay1_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pins : DO_YLED_Pin DO_BLED_Pin DO_GLED_Pin */
  GPIO_InitStruct.Pin = DO_YLED_Pin|DO_BLED_Pin|DO_GLED_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : DO_RLED2_Pin DO_RLED1_Pin DO_Relay2_Pin */
  GPIO_InitStruct.Pin = DO_RLED2_Pin|DO_RLED1_Pin|DO_Relay2_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : DO_Buzzer_Pin DO_Relay1_Pin */
  GPIO_InitStruct.Pin = DO_Buzzer_Pin|DO_Relay1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}
